#87 errors are erroneous and erratic

closed-works-for-me
LeO
Core (65)
5
2004-11-10
2004-08-25
No

First reported in forum on 2004.05.27 by me (http:
//sourceforge.net/forum/forum.php?
thread_id=1082953&forum_id=258688)...
then reported by Remco Douma on 2004.08.13 (https:
//sourceforge.net/forum/message.php?msg_id=2712764)..
.

Summary: I am consistently getting erroneous errors,
whether Unix or Windows line endings are used. First with
eclipse 2.1.3 (and epic 0.2.0), I then upgraded to eclipse
3.0 (and epic 0.3.0) and still get bogus (but different!)
errors. Also, trying the same project on different
computers (from the same eclipse .metadata) yields
different bogus errors. Finally, I'll mention for
completeness that my Java code runs flawlessly in
eclipse--no bogus errors. Any chance this is a memory
problem? I run only a 256MB machine.

Having seen no further posting since the request for
sample files a week or so ago, I took another look at the
issue. I closed all projects except my Perl one, and still
had lots of erroneous errors. I closed that project and
created a new test project. With just one file in
it--attached--the problems are still present. My system
shows 3 errors--all erroneous. If I then delete the large
comment block near the top of the file, they all go away.
(Depending on which pieces you delete, different things
happen.)

Discussion

1 2 > >> (Page 1 of 2)
  • Michael Sorens

    Michael Sorens - 2004-08-25

    shows erroneous errors

     
    Attachments
  • Jochen Ruehl

    Jochen Ruehl - 2004-08-26

    Logged In: YES
    user_id=274815

    Tried to reproduce the error with your test file.
    I Had to comment the following line because I'm missing the
    modules:

    use Date::Calc qw(Decode_Date_EU);
    use Data::Diagnostic;
    use My::UndefinedPackage;

    After that no errors were reported.

    My environment:
    Debian Linux (Sid), j2sdk1.4.2_04, Eclipse 3.0 (GTK), EPIC 0.3.6
    AMD Duron 1.2 GHz, 512 MB RAM

     
  • Jochen Ruehl

    Jochen Ruehl - 2004-08-26
    • assigned_to: nobody --> luelljoc
     
  • Michael Sorens

    Michael Sorens - 2004-08-26

    Logged In: YES
    user_id=800488

    Your response is ambiguous--you indicated you tried to
    reproduce the problem but you did not say whether you were
    successful at it. (I'm hoping you were since the status is still
    "open".)

    Note that My::UndefinedPackage is a non-existent module;
    hence, I do not have that either. I tried what you
    did--removing the three "use" lines, and errors went away. I
    also tried just commenting them out. The first time, I was still
    left with one bogus error; the second time, then I had no
    errors (i.e. the behavior is not always manifested consistently)
    .

     
  • Jochen Ruehl

    Jochen Ruehl - 2004-08-27

    Logged In: YES
    user_id=274815

    Maybe my last message was not clear enough.
    I could NOT reproduce the error.

    You could try to run your script within Eclipse and check the
    console output, maybe we get more detailed messages there.

    Not being able to reproduce a bug does not mean that I close it
    immediately. There is obviously a problem, so I'll try to fix it even if
    it might take a little bit longer.

     
  • Michael Sorens

    Michael Sorens - 2004-08-28

    Logged In: YES
    user_id=800488

    I have tried to pull out a single file or two from my code library
    that would allow you to reproduce the problem, but every time
    I try to whittle it down, it disappears.. What I can offer is my
    entire Perl library (only a couple dozen files), available on my
    website at http://cleancode.sourceforge.
    net/wwwdoc/download.html. (Note that there are some "use"
    statements referring to 3rd party modules that you would still
    need to get from CPAN if you do not already have them.) Hope
    that helps...

     
  • Nobody/Anonymous

    Logged In: NO

    I have the same problem, it seems that "use CGI;" raise the
    problem. I have it from Macintosh and PC.

    I haven't find any documentation that explain how syntax
    check is done.

     
  • LeO

    LeO - 2004-10-01

    Logged In: YES
    user_id=703323

    Hm' seems like there is Package missing - IF I look in the
    Debugger, it says

    Can't locate Math/Round.pm in @INC (@INC contains:
    C:/Perl/lib C:/Perl/site/lib) at C:/Perl/lib/Data/Handy.pm
    line 108.

    And that's not in your package-list!!!

     
  • LeO

    LeO - 2004-10-01

    Logged In: YES
    user_id=703323

    Additional comment: Could you open your Error Packages and
    try to execute them. I guess you get at each of them an Error
    due to missing other Packages.

    If we get no confirmation, we'll close this ticket.

     
  • Michael Sorens

    Michael Sorens - 2004-10-03

    Logged In: YES
    user_id=800488

    I do not have any missing packages in my environment. I
    apologize that what I suggested as a test case has some
    unstated dependencies--any such missing packages you might
    see are packages that I have installed from CPAN. There is
    probably a simpler test case to use, but I'm not sure how to
    isolate one.

     
  • LeO

    LeO - 2004-10-03

    Logged In: YES
    user_id=703323

    But let's say it that way: I've downloaded your packages,
    installed most of them and finally could see, that your
    package-list is not complete. (i used perlactive-install
    package).

    And I personally find it quite exausting to hunt down not
    included packages in your zip-file. Especially they are not all
    the time easy to find. So, at least would you provide the
    Math::Round to continue testing?

     
  • LeO

    LeO - 2004-10-04

    Logged In: YES
    user_id=703323

    I took a deeper look into the issue and I'm not quite sure,
    what is the problem of this ticket. Is it that the
    Error-Message are wrong although there is no Error or do you
    mean, the Error-Message is misleading and not specific enough?

     
  • LeO

    LeO - 2004-10-04
    • assigned_to: luelljoc --> leo_forge
     
  • Michael Sorens

    Michael Sorens - 2004-10-10

    Logged In: YES
    user_id=800488

    Here's a bit more detail on my situation (and I do not think I
    have a particularly unique environment, so probably others are
    seeing this also).

    The errors (and warnings) I am seeing are all incorrect and
    spurious--this walk-through illustrates this fact:

    Start Eclipse and open my Perl project -- 40 errors, 31
    warnings
    Invoked Project >> Clean -- now 36 errors, 58 warnings
    Opened a file with errors then closed it-- now 32 errors, 58
    warnings
    ...and that file is now error-free.
    I then proceeded to open each file with errors/warnings by
    double-clicking the item in the problem window, and
    immediately close it. All problems for the target file then
    disappeared from the problem window.
    After going through all such files, I am left with -- 0 errors, 0
    warnings

    Example of some errors:
    Inside a POD section:
    ' Semicolon seems to be missing '
    ' Bareword found where operator expected near "<item> in" '

    Observations:
    --The first error or warning seems to occur on a blank line
    following a 'use' statement. I then typically have extensive
    POD right after that, which is where (I think) all of the
    remaining incorrect errors/warnings appear.
    --None of my errors are regarding missing packages.
    --Just for clarification, my initial summary line indicated errors
    are both erroneous (that is the error message has no relation
    to the line being reported, nor to anything in the file
    sometimes) and erratic (since they disappear as I do things).

    Thanks for checking further.

    I am attaching one snapshot of the problem list and also the
    Math::Round package you requested.

     
  • Michael Sorens

    Michael Sorens - 2004-10-10

    requested Math::Round package

     
    Attachments
  • Michael Sorens

    Michael Sorens - 2004-10-10

    snapshot of problem list

     
  • LeO

    LeO - 2004-10-11

    Logged In: YES
    user_id=703323

    I'm currently stuck into reproducing your problem. And the
    stuck is in trying to open your CleanSource-project and
    seems like more and more Packages are missing.

    e.g. I open your page.pl and there is 'use Data::Diagnostic;
    ' but in the very end it points out that Getopt::ArgvFile
    is missing. Since validate.pl uses the same package => same
    result.

    Or I open Pod2HtmlTree.pl and there is 'use Pod::HtmlTree;'
    which turns finally out of missing HTML::Template.

    Or PageSequencer.pm with missing Config::General.

    etc.....

    => As I've already mentioned, I unwilling to put additonal
    effort in this issue with searching all releavant
    CPAN-Modules. From what I see of your compilation errors are
    not of missing Packages. Please provide ALL missing packages
    (even if I didn't mentioned them here).

    which version of Eclipse + epic you are using? (current
    version of epic is 0.3.8)
    are you using activePerl? which Version?

     
  • Michael Sorens

    Michael Sorens - 2004-10-12

    Logged In: YES
    user_id=800488

    I was running epic 0.3.0; I updated to 0.3.8 (as shown below)
    and still have the problem.

    Here is what I have now:
    ActivePerl 5.8.0 build 806
    eclipse version 3.0.0
    epic project 0.3.8
    (epic components: editor 0.1.9, regexp 0.1.2, debug 0.2.4)

    I have created a better test case for you that exhibits the
    problem (myTestPerl.zip attached). The only external included
    files are CGI and File::stat, both of which are standard Perl
    files, I believe.

    This test project exhibits the following errors on my system
    after I do a clean build, all on just one file:
    ------------
    Severity Description Resource In Folder Location
    Creation Time
    1 Bareword found where operator expected at - line 111,
    near ") instead" Generator.pm myTestPerl/HTML line 111
    October 11, 2004 10:02:16 PM
    1 Number found where operator expected at - line 113, near
    "over 4" Generator.pm myTestPerl/HTML line 113 October
    11, 2004 10:02:16 PM
    1 Bareword found where operator expected at - line 207,
    near "generic("xyz", "data") => <xyz>data</xyz" (Might be a
    runaway multi-line // string starting on line 121) Generator.
    pm myTestPerl/HTML line 207 October 11, 2004 10:02:16
    PM
    1 Bareword found where operator expected at - line 208,
    near "<abc>data" Generator.pm myTestPerl/HTML line 208
    October 11, 2004 10:02:16 PM
    1 Bareword found where operator expected at - line 210,
    near "data" Generator.pm myTestPerl/HTML line 210
    October 11, 2004 10:02:16 PM
    ------------
    Opening and closing the file (Generator.pm) makes the
    warnings go away. See what you can do with this.
    Thanks.

     
  • Michael Sorens

    Michael Sorens - 2004-10-12
     
    Attachments
  • LeO

    LeO - 2004-10-12

    Logged In: YES
    user_id=703323

    Hm', I don't wanna tortue you with updates, but does not
    seem the lastest version of ActivePerl is running on your
    machine. Mine says 5.8.4 (in the same constellation as
    yours) and I have NO, NO, NO problems at all when opening
    your attached files.

    Generator.pm brings no errors at all.

    So, would you mind to upgrade to lastest Perl version and
    lets see again, what happens. Then we would have the same
    test-equiment!

     
  • Michael Sorens

    Michael Sorens - 2004-10-16

    Logged In: YES
    user_id=800488

    I won't be able to upgrade my perl version in the near future;
    let me know if you have other suggestions in the meantime.

     
  • LeO

    LeO - 2004-10-18

    Logged In: YES
    user_id=703323

    1) Try to disable the taint-option, what is the result?

    2) Try on a DOS-Box

    perl -c Generator.pm

    as well with the option -w and/or -T

    Attach the results to this entry.

     
  • Michael Sorens

    Michael Sorens - 2004-10-20

    Logged In: YES
    user_id=800488

    (1) Please let me know where you see the taint option
    enabled; I do not see a -T in any of my three files.

    (2) perl -c Generator.pm simply reports "Generator.pm OK"

    (3) In eclipse, I did try removing the -w from all 3 files and
    then doing a clean build, but with no change (i.e. same errors)
    .

     
  • LeO

    LeO - 2004-10-21

    Logged In: YES
    user_id=703323

    (1) In eclipse Window -> Preference -> EPIC, what
    preferences have you set on the main-page?

    (2) as I assumed

    but what is reported in a DOS-Box with

    perl -c -w Generator.pm
    perl -c -w -T Generator.pm

    ???
    (3) ????

     
  • Michael Sorens

    Michael Sorens - 2004-10-21

    Logged In: YES
    user_id=800488

    (1) Ahh... I wasn't thinking about Preferences. Here is what I
    have:
    EPIC main page preferences:
    interpreter type -- standard
    enable warnings -- off
    enable taint -- off
    validate source when idle for 400 ms

    I also tried switching warnings and taint to on, but there was
    no difference (i.e. still same erroneous warnings reported).

    (2) perl -c -w Generator.pm yields:
    Generator.pm syntax OK

    perl -c -w -T Generator.pm yields:
    Generator.pm syntax OK

    (3) I further reduced the size of my test case to just one file
    --Generator.pm -- with one include -- CGI. If I either remove
    or comment out the 'use CGI' the warnings go away.
    Therefore, I have bundled up the revised Generator.pm with
    my version of CGI.pm (v2.81) and its corresponding support
    CGI folder, copied from my \perl\lib directory. I am hoping that
    you could reproduce the problem with this version of CGI,
    since that seems to be the culprit.

     
1 2 > >> (Page 1 of 2)

Get latest updates about Open Source Projects, Conferences and News.

Sign up for the SourceForge newsletter:





No, thanks